<%
#-----------------------------------------------------------------
# GDL
# Connecting People's Knowledge
# Copyright (c) 1998-2001 by KMRG ITB, kmrg@kmrg.lib.itb.ac.id
# Version 3.1, April 2001, by: Ismail Fahmi, ismail@itb.ac.id
# Free for IndonesiaDLN Members
#-----------------------------------------------------------------

function readXML($xmldata) {
	$xmldata = stripslashes($xmldata);
	$parser = xml_parser_create();
	xml_parser_set_option($parser,XML_OPTION_CASE_FOLDING,1);
	xml_parser_set_option($parser,XML_OPTION_SKIP_WHITE,1);
	xml_parse_into_struct($parser,$xmldata,&$values,&$tags);
	xml_parser_free($parser);

	$xml_perseption = "";
	
	foreach ($tags as $key=>$val) {
		#echo "$key---->$val\n";
		if ($key == "INDONESIADLN") {
			$molranges = $val;
			for ($i=0; $i < count($molranges); $i+=2) {
			    $offset = $molranges[$i] + 1;
				$len = $molranges[$i + 1] - $offset;
				$pmv = array_slice($values, $offset, $len);
				$pm = parseMol($pmv);
				$tdb[] = $pm;
			}
		} else {
			continue;
		}
	}
	return $tdb;
}

function parseMol($mvalues) {
	global $xml;
	global $xml_perseption;

	for ($j=0; $j < count($mvalues); $j++) {
		$tag = $mvalues[$j]["tag"];
		$value = $mvalues[$j]["value"];
		$type = $mvalues[$j]["type"];
		$mol[$tag] = $value;
		if ($type == "open"){
			if (!empty($parent)){
				$parent2 = "$parent.$tag";
				$level = 3;
			} else {
				$parent = $tag;
				$level = 2;
			}
		} elseif ($type == "close") {
			if (!empty($parent2)){
				$parent2 = "";
				$level = 2;
			} else {
				$parent = "";
				$level = 1;
			}
		} 
		
		if ($level == 3){
			if ($type == "open"){
				$mytag = strtoupper("$parent.$tag"); 
				$xml[$mytag][] = $value;
			} elseif ($type == "close"){
			} else {
				$mytag = strtoupper("$parent2.$tag"); 
				$xml[$mytag][] = $value;
			}
		} elseif ($level == 2){
			if ($type == "open"){
				$mytag = strtoupper($tag);
				$xml[$mytag][] = $value;

			} elseif ($type == "close"){
			} else {
				$mytag = strtoupper("$parent.$tag");
				$xml[$mytag][] = $value;
			}
		} elseif ($type == "close"){
		} else {
			$mytag = strtoupper($tag);
			$xml[$mytag][] = $value;
		}		
		#echo "<br>$mytag  = $value";
		$xml_perseption .= "<br>$mytag  = $value";
	}
}

%>
